      SUBROUTINE rhs3d_w_nh(tile)
      implicit none
      integer*4 tile, trd, omp_get_thread_num
      integer*4  LLm,Lm,MMm,Mm,N, LLm0,MMm0
      parameter (LLm0=128,  MMm0=1,   N=128)
      parameter (LLm=LLm0,  MMm=MMm0)
      integer*4 Lmmpi,Mmmpi,iminmpi,imaxmpi,jminmpi,jmaxmpi
      common /comm_setup_mpi1/ Lmmpi,Mmmpi
      common /comm_setup_mpi2/ iminmpi,imaxmpi,jminmpi,jmaxmpi
      integer*4 NSUB_X, NSUB_E, NPP
      parameter (NPP=1)
      parameter (NSUB_X=1, NSUB_E=NPP)
      integer*4 NWEIGHT
      parameter (NWEIGHT=1000)
      integer*4 stdout, Np, padd_X,padd_E
      parameter (stdout=6)
      parameter (Np=N+1)
      parameter (Lm=LLm, Mm=MMm)
      parameter (padd_X=(Lm+2)/2-(Lm+1)/2)
      parameter (padd_E=(Mm+2)/2-(Mm+1)/2)
      integer*4 NSA, N2d,N3d, size_XI,size_ETA
      integer*4 se,sse, sz,ssz
      parameter (NSA=35)
      parameter (size_XI=7+(Lm+NSUB_X-1)/NSUB_X)
      parameter (size_ETA=7+(Mm+NSUB_E-1)/NSUB_E)
      parameter (sse=size_ETA/Np, ssz=Np/size_ETA)
      parameter (se=sse/(sse+ssz), sz=1-se)
      parameter (N2d=size_XI*(se*size_ETA+sz*Np))
      parameter (N3d=size_XI*size_ETA*Np)
      real Vtransform
      parameter (Vtransform=2)
      integer*4   NT, itemp
      integer*4   ntrc_salt, ntrc_pas, ntrc_bio, ntrc_sed
      parameter (itemp=1)
      parameter (ntrc_salt=0)
      parameter (ntrc_pas=0)
      parameter (ntrc_bio=0)
      parameter (ntrc_sed=0)
      parameter (NT=itemp+ntrc_salt+ntrc_pas+ntrc_bio+ntrc_sed)
      integer*4   ntrc_diats, ntrc_diauv, ntrc_diabio
      integer*4   ntrc_diavrt, ntrc_diaek, ntrc_diapv
      integer*4   ntrc_diaeddy, ntrc_surf
      parameter (ntrc_diabio=0)
      parameter (ntrc_diats=0)
      parameter (ntrc_diauv=0)
      parameter (ntrc_diavrt=0)
      parameter (ntrc_diaek=0)
      parameter (ntrc_diapv=0)
      parameter (ntrc_diaeddy=0)
      parameter (ntrc_surf=0)
      real A2d(N2d,NSA,0:NPP-1), A3d(N3d,7,0:NPP-1)
      common/private_scratch/ A2d,A3d
      integer*4 chunk_size_X,margin_X,chunk_size_E,margin_E
      integer*4 Istr,Iend,Jstr,Jend, i_X,j_E
      chunk_size_X=(Lm+NSUB_X-1)/NSUB_X
      margin_X=(NSUB_X*chunk_size_X-Lm)/2
      chunk_size_E=(Mm+NSUB_E-1)/NSUB_E
      margin_E=(NSUB_E*chunk_size_E-Mm)/2
      j_E=tile/NSUB_X
      i_X=tile-j_E*NSUB_X
      Istr=1+i_X*chunk_size_X-margin_X
      Iend=Istr+chunk_size_X-1
      Istr=max(Istr,1)
      Iend=min(Iend,Lm)
      Jstr=1+j_E*chunk_size_E-margin_E
      Jend=Jstr+chunk_size_E-1
      Jstr=max(Jstr,1)
      Jend=min(Jend,Mm)
      trd=omp_get_thread_num()
      CALL rhs3d_w_tile (Istr,Iend,Jstr,Jend,  A3d(1,3,trd),
     &             A2d(1,1,trd), A2d(1,2,trd), A2d(1,3,trd),
     &             A2d(1,4,trd), A2d(1,5,trd), A2d(1,6,trd),
     &             A2d(1,7,trd), A3d(1,4,trd), A3d(1,5,trd)
     &                                                     )
      return
      END
      SUBROUTINE rhs3d_w_tile (istr, iend,   jstr,   jend, rw ,
     &                           CF,   FC,  We_r ,    lap, Hzw,
     &                          WFx,  WFe, HUon_w, HVom_w       )
      IMPLICIT NONE
      INTEGER*4  :: Istr,Iend,Jstr,Jend
      INTEGER*4  :: i,j,k,kp
      INTEGER*4  :: imin,imax,jmin,jmax
      real        rr,rrm,rrp,limiter2,Cr,cdt,cu
      integer*4     kp2,kp1,km1
      integer*4  LLm,Lm,MMm,Mm,N, LLm0,MMm0
      parameter (LLm0=128,  MMm0=1,   N=128)
      parameter (LLm=LLm0,  MMm=MMm0)
      integer*4 Lmmpi,Mmmpi,iminmpi,imaxmpi,jminmpi,jmaxmpi
      common /comm_setup_mpi1/ Lmmpi,Mmmpi
      common /comm_setup_mpi2/ iminmpi,imaxmpi,jminmpi,jmaxmpi
      integer*4 NSUB_X, NSUB_E, NPP
      parameter (NPP=1)
      parameter (NSUB_X=1, NSUB_E=NPP)
      integer*4 NWEIGHT
      parameter (NWEIGHT=1000)
      integer*4 stdout, Np, padd_X,padd_E
      parameter (stdout=6)
      parameter (Np=N+1)
      parameter (Lm=LLm, Mm=MMm)
      parameter (padd_X=(Lm+2)/2-(Lm+1)/2)
      parameter (padd_E=(Mm+2)/2-(Mm+1)/2)
      integer*4 NSA, N2d,N3d, size_XI,size_ETA
      integer*4 se,sse, sz,ssz
      parameter (NSA=35)
      parameter (size_XI=7+(Lm+NSUB_X-1)/NSUB_X)
      parameter (size_ETA=7+(Mm+NSUB_E-1)/NSUB_E)
      parameter (sse=size_ETA/Np, ssz=Np/size_ETA)
      parameter (se=sse/(sse+ssz), sz=1-se)
      parameter (N2d=size_XI*(se*size_ETA+sz*Np))
      parameter (N3d=size_XI*size_ETA*Np)
      real Vtransform
      parameter (Vtransform=2)
      integer*4   NT, itemp
      integer*4   ntrc_salt, ntrc_pas, ntrc_bio, ntrc_sed
      parameter (itemp=1)
      parameter (ntrc_salt=0)
      parameter (ntrc_pas=0)
      parameter (ntrc_bio=0)
      parameter (ntrc_sed=0)
      parameter (NT=itemp+ntrc_salt+ntrc_pas+ntrc_bio+ntrc_sed)
      integer*4   ntrc_diats, ntrc_diauv, ntrc_diabio
      integer*4   ntrc_diavrt, ntrc_diaek, ntrc_diapv
      integer*4   ntrc_diaeddy, ntrc_surf
      parameter (ntrc_diabio=0)
      parameter (ntrc_diats=0)
      parameter (ntrc_diauv=0)
      parameter (ntrc_diavrt=0)
      parameter (ntrc_diaek=0)
      parameter (ntrc_diapv=0)
      parameter (ntrc_diaeddy=0)
      parameter (ntrc_surf=0)
      REAL     :: rw     (Istr-2:Iend+2,Jstr-2:Jend+2,0:N  )
      REAL     :: CF     (Istr-2:Iend+2,0:N  )
      REAL     :: FC     (Istr-2:Iend+2,0:N+1)
      REAL     :: We_r   (Istr-2:Iend+2,0:N+1)
      REAL     :: lap    (Istr-2:Iend+2,Jstr-2:Jend+2      )
      REAL     :: Hzw    (Istr-2:Iend+2,0:N  )
      REAL     :: WFx    (Istr-2:Iend+2,Jstr-2:Jend+2      )
      REAL     :: WFe    (Istr-2:Iend+2,Jstr-2:Jend+2      )
      REAL     :: HUon_w (Istr-2:Iend+2,Jstr-2:Jend+2,0:N  )
      REAL     :: HVom_w (Istr-2:Iend+2,Jstr-2:Jend+2,0:N  )
      REAL     :: gamma, epsil, cff, cff1, cff2, cff3, Omeg_r
      REAL     :: wz_bot,wz_sfc
      PARAMETER (gamma=0.25D0  )
      PARAMETER (epsil=1.D-16)
      real h(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real hinv(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real f(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real fomn(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /grid_h/h /grid_hinv/hinv /grid_f/f /grid_fomn/fomn
      real xp(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real xr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real yp(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real yr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /grid_xr/xr /grid_xp/xp /grid_yp/yp /grid_yr/yr
      real pm(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pn(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real om_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real on_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pn_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pm_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pm_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pn_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /metrics_pm/pm    /metrics_pn/pn
      common /metrics_omr/om_r /metrics_on_r/on_r
      common /metrics_omu/om_u /metrics_on_u/on_u
      common /metrics_omv/om_v /metrics_on_v/on_v
      common /metrics_omp/om_p /metrics_on_p/on_p
      common /metrics_pnu/pn_u /metrics_pmv/pm_v
      common /metrics_pmu/pm_u /metrics_pnv/pn_v
      real pmon_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pmon_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pmon_u(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pnom_p(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pnom_r(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real pnom_v(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real grdscl(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /metrics_pmon_p/pmon_p /metrics_pnom_p/pnom_p
      common /metrics_pmon_r/pmon_r /metrics_pnom_r/pnom_r
      common /metrics_pmon_u/pmon_u /metrics_pnom_v/pnom_v
      common /metrics_grdscl/grdscl
      real zob(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /Z0B_VAR/zob
      real u(-2:Lm+3+padd_X,0:Mm+1+padd_E,N,3)
      real v(-2:Lm+3+padd_X,0:Mm+1+padd_E,N,3)
      real t(-2:Lm+3+padd_X,0:Mm+1+padd_E,N,3,NT)
      common /ocean_u/u /ocean_v/v /ocean_t/t
      real Hz(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real Hz_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real z_r(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real z_w(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      real Huon(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real Hvom(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /grid_Hz_bak/Hz_bak /grid_zw/z_w /grid_Huon/Huon
      common /grid_Hvom/Hvom
      real We(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /grid_Hz/Hz /grid_zr/z_r /grid_We/We
      real wz(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N,3)
      common /ocean_wz/wz
      real rho1(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      real rho(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /ocean_rho1/rho1 /ocean_rho/rho
      real rhoA(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real rhoS(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /coup_rhoA/rhoA           /coup_rhoS/rhoS
      real rufrc(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real rvfrc(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real rufrc_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      real rvfrc_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      common /coup_rufrc/rufrc
      common /coup_rvfrc/rvfrc
      common /coup_rufrc_bak/rufrc_bak
      common /coup_rvfrc_bak/rvfrc_bak
      real Zt_avg1(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real DU_avg1(-2:Lm+3+padd_X,0:Mm+1+padd_E,5)
      real DV_avg1(-2:Lm+3+padd_X,0:Mm+1+padd_E,5)
      real DU_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real DV_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /ocean_Zt_avg1/Zt_avg1
      common /coup_DU_avg1/DU_avg1
      common /coup_DV_avg1/DV_avg1
      common /coup_DU_avg2/DU_avg2
      common /coup_DV_avg2/DV_avg2
      real sustr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real svstr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /forces_sustr/sustr /forces_svstr/svstr
      real bustr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      real bvstr(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /forces_bustr/bustr /forces_bvstr/bvstr
      real bustrg(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      real bvstrg(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      common /bmsdat_bustrg/bustrg /bmsdat_bvstrg/bvstrg
      real bms_tintrp(2), bustrp(2),    bvstrp(2), tbms(2)
      real bmsclen, bms_tstart, bms_tend,  tsbms, sclbms
      integer*4 itbms,      bmstid,busid, bvsid,     tbmsindx
      logical bmscycle,   bms_onerec,   lbusgrd,   lbvsgrd
      common /bmsdat1/bms_tintrp, bustrp,       bvstrp,    tbms
      common /bmsdat2/bmsclen, bms_tstart, bms_tend, tsbms, sclbms
      common /bmsdat3/itbms,      bmstid,busid, bvsid,     tbmsindx
      common /bmsdat4/bmscycle,   bms_onerec,   lbusgrd,   lbvsgrd
      real stflx(-2:Lm+3+padd_X,0:Mm+1+padd_E,NT)
      common /forces_stflx/stflx
      real btflx(-2:Lm+3+padd_X,0:Mm+1+padd_E,NT)
      common /forces_btflx/btflx
      real srflx(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /forces_srflx/srflx
      real srflxg(-2:Lm+3+padd_X,0:Mm+1+padd_E,2)
      common /srfdat_srflxg/srflxg
      real srflxp(2),srf_time(2)
      real srf_cycle, srf_scale
      integer*4 itsrf, srf_ncycle, srf_rec
      integer*4 lsrfgrd, srf_tid, srf_id
      common /srfdat1/ srflxp, srf_time, srf_cycle, srf_scale
      common /srfdat2/ itsrf,srf_ncycle,srf_rec,lsrfgrd,srf_tid,srf_id
      real dt, dtfast, time, time2, time_start, tdays
      integer*4 ndtfast, iic, kstp, krhs, knew, next_kstp
     &      , iif, nstp, nrhs, nnew, nbstep3d
      logical PREDICTOR_2D_STEP
      common /time_indices/  dt,dtfast, time, time2,time_start, tdays,
     &                       ndtfast, iic, kstp, krhs, knew, next_kstp,
     &                       iif, nstp, nrhs, nnew, nbstep3d,
     &                       PREDICTOR_2D_STEP
      real time_avg, time2_avg, rho0
     &               , rdrg, rdrg2, Cdb_min, Cdb_max, Zobt
     &               , xl, el, visc2, visc4, gamma2
      real  theta_s,   theta_b,   Tcline,  hc
      real  sc_w(0:N), Cs_w(0:N), sc_r(N), Cs_r(N)
      real  rx0, rx1
      real  tnu2(NT),tnu4(NT)
      real R0,T0,S0, Tcoef, Scoef
      real weight(6,0:NWEIGHT)
      integer*4 numthreads,     ntstart,   ntimes,  ninfo
     &      , nfast,  nrrec,     nrst,    nwrt
      logical ldefhis
      logical got_tini(NT)
      common /scalars_main/
     &             time_avg, time2_avg,  rho0,      rdrg,    rdrg2
     &           , Zobt,       Cdb_min,   Cdb_max
     &           , xl, el,    visc2,     visc4,   gamma2
     &           , theta_s,   theta_b,   Tcline,  hc
     &           , sc_w,      Cs_w,      sc_r,    Cs_r
     &           , rx0,       rx1,       tnu2,    tnu4
     &                      , R0,T0,S0,  Tcoef,   Scoef
     &                      , weight
     &      , numthreads,     ntstart,   ntimes,  ninfo
     &      , nfast,  nrrec,     nrst,    nwrt
     &                      , got_tini
     &                      , ldefhis
      real Akv_bak
      real Akt_bak(NT)
      common /scalars_akt/ Akv_bak, Akt_bak
      logical synchro_flag
      common /sync_flag/ synchro_flag
      integer*4 may_day_flag
      integer*4 tile_count, first_time, bc_count
      common /communicators_i/
     &        may_day_flag, tile_count, first_time, bc_count
      real hmin, hmax, grdmin, grdmax, Cu_min, Cu_max
      common /communicators_r/
     &     hmin, hmax, grdmin, grdmax, Cu_min, Cu_max
      real*8 Cu_Adv3d,  Cu_W, Cu_Nbq_X, Cu_Nbq_Y, Cu_Nbq_Z
      integer*4 i_cx_max, j_cx_max, k_cx_max
      common /diag_vars/ Cu_Adv3d,  Cu_W,
     &        i_cx_max, j_cx_max, k_cx_max
      real*8 volume, avgke, avgpe, avgkp, bc_crss
     &        , avg_vol, avg_rho
      common /communicators_rq/
     &          volume, avgke, avgpe, avgkp, bc_crss
     &        , avg_vol, avg_rho
      real*4 CPU_time(0:31,0:NPP)
      integer*4 proc(0:31,0:NPP),trd_count
      common /timers_roms/CPU_time,proc,trd_count
      real pi, deg2rad, rad2deg
      parameter (pi=3.14159265358979323846D0, deg2rad=pi/180.D0,
     &                                      rad2deg=180.D0/pi)
      real Eradius, Erotation, g, day2sec,sec2day, jul_off,
     &     year2day,day2year
      parameter (Eradius=6371315.0D0,  Erotation=7.292115090D-5,
     &           day2sec=86400.D0, sec2day=1.D0/86400.D0,
     &           year2day=365.25D0, day2year=1.D0/365.25D0,
     &           jul_off=2440000.D0)
      parameter (g=9.81D0)
      real Cp
      parameter (Cp=3985.0D0)
      real vonKar
      parameter (vonKar=0.41D0)
      real spval
      parameter (spval=0.0D0)
      logical mask_val
      parameter (mask_val = .true.)
      logical M2bc_nbq_flag
      common /nbq_M2bc/ M2bc_nbq_flag
      integer*4 iteration_nbq_max
      common /nbq_var1/ iteration_nbq_max
      integer*4 iteration_nbq
      common /nbq_var2/ iteration_nbq
      integer*4 ifl_nbq
      common /nbq_var3/ ifl_nbq
      integer*4 slip_nbq
      common /nbq_var4/ slip_nbq
      real soundspeed_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_param1/ soundspeed_nbq
      real soundspeed2_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_param2/ soundspeed2_nbq
      double precision time_nbq
      common /nbq_param3/ time_nbq
      double precision csvisc1_nbq
      common /nbq_param4/ csvisc1_nbq
      double precision csvisc2_nbq
      common /nbq_param5/ csvisc2_nbq
      double precision cw_int_nbq
      common /nbq_param6/ cw_int_nbq
      double precision ifl_imp_nbq
      common /nbq_param7/ ifl_imp_nbq
      integer*4 ndtnbq
      common /time_nbq1/ ndtnbq
      real dtnbq
      common /time_nbq2/ dtnbq
      real csound_nbq
      common /nbq_csound/ csound_nbq
      real visc2_nbq
      common /nbq_visc2/ visc2_nbq
      real dtgrid_nbq
      common /nbq_dtgrid/ dtgrid_nbq
      real qdmu_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_qdmu_nbq/ qdmu_nbq
      real qdmv_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_qdmv_nbq/ qdmv_nbq
      real qdmw_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /nbq_qdmw_nbq/ qdmw_nbq
      real thetadiv_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_thetadiv_nbq/ thetadiv_nbq
      real thetadiv2_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_thetadiv2_nbq/ thetadiv2_nbq
      real thetadiv3_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_thetadiv3_nbq/ thetadiv3_nbq
      real ru_int_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_ruint/ ru_int_nbq
      real rv_int_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_rvint/ rv_int_nbq
      real ru_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_ru/ ru_nbq
      real rv_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /nbq_rv/ rv_nbq
      real ru_nbq_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /avg2_runbq/ ru_nbq_avg2
      real rv_nbq_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common /avg2_rvnbq/ rv_nbq_avg2
      real rw_int_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /nbq_rwint/ rw_int_nbq
      real rw_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /nbq_rw/ rw_nbq
      real rw_nbq_avg2(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /avg2_rwnbq/ rw_nbq_avg2
      real rho_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common/nbq_rho_nbq/rho_nbq
      integer*4 inc_faststep
      common/nbq_inc_faststep/inc_faststep
      integer*4 nb_faststep
      common/nbq_nb_faststep/nb_faststep
      real DU_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_DU_nbq/ DU_nbq
      real DV_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_DV_nbq/ DV_nbq
      real ru_int_nbq_2d (-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_ruint_2d/ru_int_nbq_2d
      real rv_int_nbq_2d (-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_rvint_2d/rv_int_nbq_2d
      real rho_grd(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common/nbq_rho_grd/rho_grd
      real rho_bak(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
      common/nbq_rho_bak/rho_bak
      real Hzw_half_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N)
      common /grid_Hzw_half_nbq/ Hzw_half_nbq
      real zw_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N,4)
      common /nbq_zw/ zw_nbq
       real Hz_correct(-2:Lm+3+padd_X,0:Mm+1+padd_E,N)
       common /grid_Hz_correct/ Hz_correct
      real dthetadiv_nbqdz(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N,2)
      common /nbq_nods3/ dthetadiv_nbqdz
      real dZdxq_w(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N+1)
      common /nbq_nods5/ dZdxq_w
      real dZdyq_w(-2:Lm+3+padd_X,0:Mm+1+padd_E,0:N+1)
      common /nbq_nods7/ dZdyq_w
      real wsurf_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_wsurf/ wsurf_nbq
      real usurf_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_usurf/ usurf_nbq
      real vsurf_nbq(-2:Lm+3+padd_X,0:Mm+1+padd_E)
      common /nbq_vsurf/ vsurf_nbq
      REAL    :: q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2
      REAL    :: ua, vel, cdiff, cdif
      REAL    :: flux1, flux2, flux3, flux4, flux5, flux6
      REAL    :: flx2, flx3, flx4, flx5
      REAL    :: mask0, mask1, mask2, mask3
      flux2(q_im1, q_i, ua, cdiff) = 0.5D0*( q_i + q_im1 )
      flux1(q_im1, q_i, ua, cdiff) = flux2(q_im1, q_i, ua, cdiff) -
     &      0.5D0*cdiff*sign(1.D0,ua)*(q_i-q_im1)
      flux4(q_im2, q_im1, q_i, q_ip1, ua) =
     &      ( 7.D0*(q_i + q_im1) - (q_ip1 + q_im2) )/12.0D0
      flux3(q_im2, q_im1, q_i, q_ip1, ua) =
     &      flux4(q_im2, q_im1, q_i, q_ip1, ua) +
     &      sign(1.D0,ua)*((q_ip1 -
     &      q_im2)-3.D0*(q_i-q_im1))/12.0D0
      flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =
     &      ( 37.D0*(q_i+q_im1) - 8.D0*(q_ip1+q_im2)
     &      +(q_ip2+q_im3) )/60.0D0
      flux5(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =
     &      flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua)
     &      -sign(1.D0,ua)*(
     &      (q_ip2-q_im3)-5.D0*(q_ip1-q_im2)+10.D0*(q_i-q_im1) )/60.0D0
      REAL    :: flux3_weno, flux5_weno
      integer*4 IstrR,IendR,JstrR,JendR
      integer*4 JstrV
      if (istr.eq.1) then
        IstrR=Istr-2
      else
        IstrR=Istr
      endif
      if (iend.eq.Lm) then
        IendR=Iend+2
      else
        IendR=Iend
      endif
      if (jstr.eq.1) then
        JstrR=Jstr-1
        JstrV=Jstr+1
      else
        JstrR=Jstr
        JstrV=Jstr
      endif
      if (jend.eq.Mm) then
        JendR=Jend+1
      else
        JendR=Jend
      endif
      DO j = jstr,jend
        DO i = istr,iend+1
          HUon_w(i,j,0)=0.5D0*HUon(i,j,1)
          HUon_w(i,j,N)=0.5D0*HUon(i,j,N)
        ENDDO
      ENDDO
      DO j = jstr,jend+1
        DO i = istr,iend
          HVom_w(i,j,0)=0.5D0*HVom(i,j,1)
          HVom_w(i,j,N)=0.5D0*HVom(i,j,N)
        ENDDO
      ENDDO
      DO k = 1,N-1
        DO j = jstr,jend
          DO i = istr,iend+1
            HUon_w(i,j,k)=0.5D0*( HUon(i,j,k)+HUon(i,j,k+1) )
          ENDDO
        ENDDO
        DO j = jstr,jend+1
          DO i = istr,iend
            HVom_w(i,j,k)=0.5D0*( HVom(i,j,k)+HVom(i,j,k+1) )
          ENDDO
        ENDDO
      ENDDO
      DO k = 0, N
         DO j = jstr,jend
            DO i = istr,iend
              rw(i,j,k) = 0.D0
            ENDDO
         ENDDO
      ENDDO
      jmin=3
      jmax=Mm-1
      imin=1
      imax=Lm+1
      DO k=0,N
          cdif=1.D0
          DO j = Jstr,Jend+1
            IF ( j.ge.jmin .and. j.le.jmax ) THEN
              DO i = Istr,Iend
                vel = Hvom_w(i,j,k)
                flx5 = vel*flux5_weno(
     &             wz(i,j-3,k,nrhs), wz(i,j-2,k,nrhs),
     &             wz(i,j-1,k,nrhs), wz(i,j  ,k,nrhs),
     &             wz(i,j+1,k,nrhs), wz(i,j+2,k,nrhs),  vel )
                WFe(i,j)=flx5
              ENDDO
            ELSE IF ( j.eq.jmin-2 ) THEN
              DO i = Istr,Iend
                vel = Hvom_w(i,j,k)
                WFe(i,j) = vel*flux1(
     &             wz(i,j-1,k,nrhs), wz(i,j,k,nrhs), vel, cdif)
              ENDDO
            ELSE IF ( j.eq.jmin-1 .and. jmax.ge.jmin ) THEN
              DO i = Istr,Iend
                vel = Hvom_w(i,j,k)
                flx3 = vel*flux3_weno(
     &             wz(i,j-2,k,nrhs), wz(i,j-1,k,nrhs),
     &             wz(i,j  ,k,nrhs), wz(i,j+1,k,nrhs),  vel )
                WFe(i,j)=flx3
              ENDDO
            ELSE IF ( j.eq.jmax+2 ) THEN
              DO i = Istr,Iend
                vel = Hvom_w(i,j,k)
                WFe(i,j) = vel*flux1(
     &             wz(i,j-1,k,nrhs), wz(i,j,k,nrhs), vel, cdif)
              ENDDO
            ELSE IF ( j.eq.jmax+1 ) THEN
              DO i = Istr,Iend
                vel = Hvom_w(i,j,k)
                flx3 = vel*flux3_weno(
     &             wz(i,j-2,k,nrhs), wz(i,j-1,k,nrhs),
     &             wz(i,j  ,k,nrhs), wz(i,j+1,k,nrhs),  vel )
                WFe(i,j)=flx3
              ENDDO
            ENDIF
          ENDDO
          DO i = Istr,Iend+1
            IF ( i.ge.imin .and. i.le.imax ) THEN
              DO j = Jstr,Jend
                vel = Huon_w(i,j,k)
                flx5 = vel*flux5_weno(
     &             wz(i-3,j,k,nrhs), wz(i-2,j,k,nrhs),
     &             wz(i-1,j,k,nrhs), wz(i  ,j,k,nrhs),
     &             wz(i+1,j,k,nrhs), wz(i+2,j,k,nrhs),  vel )
                WFx(i,j)=flx5
              ENDDO
            ELSE IF ( i.eq.imin-2 ) THEN
              DO j = Jstr,Jend
                vel = Huon_w(i,j,k)
                WFx(i,j) = vel*flux1(
     &             wz(i-1,j,k,nrhs), wz(i,j,k,nrhs), vel, cdif)
              ENDDO
            ELSE IF ( i.eq.imin-1 .and. imax.ge.imin ) THEN
              DO j = Jstr,Jend
                vel = Huon_w(i,j,k)
                flx3 = vel*flux3_weno(
     &             wz(i-2,j,k,nrhs), wz(i-1,j,k,nrhs),
     &             wz(i  ,j,k,nrhs), wz(i+1,j,k,nrhs),  vel )
                WFx(i,j)=flx3
              ENDDO
            ELSE IF ( i.eq.imax+2 ) THEN
              DO j = Jstr,Jend
                vel = Huon_w(i,j,k)
                WFx(i,j) = vel*flux1(
     &             wz(i-1,j,k,nrhs), wz(i,j,k,nrhs), vel, cdif)
              ENDDO
            ELSE IF ( i.eq.imax+1 ) THEN
              DO j = Jstr,Jend
                vel = Huon_w(i,j,k)
                flx3 = vel*flux3_weno(
     &             wz(i-2,j,k,nrhs), wz(i-1,j,k,nrhs),
     &             wz(i  ,j,k,nrhs), wz(i+1,j,k,nrhs),  vel )
                WFx(i,j)=flx3
              ENDDO
            ENDIF
          ENDDO
        DO j=Jstr,Jend
          DO i=Istr,Iend
            rw(i,j,k)= rw(i,j,k) - WFx(i+1,j) + WFx(i,j)
     &                           - WFe(i,j+1) + WFe(i,j)
          ENDDO
        ENDDO
      ENDDO
      IF(nrhs.eq.3) then
        DO j=Jstr,Jend
          DO i=Istr,Iend+1
            WFx(i,j) = 0.D0
            Huon_w(i,j,0) = DU_avg2(i,j)
            Huon_w(i,j,1) = u(i,j,N,nrhs) * pm_u(i,j)
     &                                 * ( z_w(i  ,j,N)-z_w(i-1,j,N) )
          ENDDO
        ENDDO
        DO j=Jstr,Jend+1
          DO i=Istr,Iend
            WFe(i,j) = 0.D0
            Hvom_w(i,j,0)  = DV_avg2(i,j)
            Hvom_w(i,j,1) = v(i,j,N,nrhs) * pn_v(i,j)
     &                                 * ( z_w(i,j,N)-z_w(i,j-1,N) )
          ENDDO
        ENDDO
      ELSE
        DO j=Jstr,Jend
          DO i=Istr,Iend+1
            WFx(i,j) = 0.D0
            Huon_w(i,j,0) = DU_avg1(i,j,nstp)
            Huon_w(i,j,1) = u(i,j,N,nstp) * pm_u(i,j)
     &                                 * ( z_w(i  ,j,N)-z_w(i-1,j,N) )
          ENDDO
        ENDDO
        DO j=Jstr,Jend+1
          DO i=Istr,Iend
            WFe(i,j) = 0.D0
            Hvom_w(i,j,0) = DV_avg1(i,j,nstp)
            Hvom_w(i,j,1) = v(i,j,N,nstp) * pn_v(i,j)
     &                                 * ( z_w(i,j,N)-z_w(i,j-1,N) )
          ENDDO
        ENDDO
      ENDIF
      DO j=Jstr,Jend
        DO i=Istr,Iend
          wz(i,j,0,nnew) = 0.D0
        ENDDO
      ENDDO
      DO j=Jstr,Jend
        DO i=Istr,Iend
          Hzw (i,0  ) = 0.5D0 * Hz(i,j,1)
          Hzw (i,N  ) = 0.5D0 * Hz(i,j,N)
          We_r(i,0  ) =        We(i,j,0)
          We_r(i,N  ) = 0.5D0 * (We(i,j,N)+We(i,j,N-1))
          We_r(i,N+1) =        We(i,j,N)
        ENDDO
        DO k=1,N-1
          DO i=Istr,Iend
            Hzw (i,k) = 0.5D0 * ( Hz(i,j,k) + Hz(i,j,k+1) )
            We_r(i,k) = 0.5D0 * ( We (i,j,k) + We (i,j,k-1) )
          ENDDO
        ENDDO
          cdif=1.D0
          do k=3,N-2
            do i=Istr,Iend
              FC(i,k)=We_r(i,k)*flux5_weno(
     &             wz(i,j,k-3,nrhs), wz(i,j,k-2,nrhs),
     &             wz(i,j,k-1,nrhs), wz(i,j,k  ,nrhs),
     &             wz(i,j,k+1,nrhs), wz(i,j,k+2,nrhs), We_r(i,k))
            enddo
          enddo
          do i=Istr,Iend
            FC(i,2)=We_r(i,2)*flux3_weno(
     &           wz(i,j,0,nrhs), wz(i,j,1,nrhs),
     &           wz(i,j,2,nrhs), wz(i,j,3,nrhs), We_r(i,2))
            FC(i,N-1)=We_r(i,N-1)*flux3_weno(
     &           wz(i,j,N-3,nrhs), wz(i,j,N-2,nrhs),
     &           wz(i,j,N-1,nrhs), wz(i,j,N  ,nrhs), We_r(i,N-1))
            FC(i,1)=We_r(i,1)*flux1( wz(i,j,1  ,nrhs),
     &                               wz(i,j,0  ,nrhs), We_r(i,1), 1.D0)
            FC(i,N)=We_r(i,N)*flux1( wz(i,j,N  ,nrhs),
     &                               wz(i,j,N-1,nrhs), We_r(i,N), 1.D0)
            FC(i,0)=0.D0
            FC(i,N+1)=0.D0
          enddo
        DO k=1,N
          DO i=Istr,Iend
            rw(i,j,k) = rw(i,j,k)  - FC(i,k+1) + FC(i,k)
          ENDDO
        ENDDO
      ENDDO
      return
      end
